unit Connection.Types;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, mysql56conn, DB;

type
  {$Macro On}
  {$Define EXC:=class(Exception)}
  TMySQLConnection = TMySQL56Connection;

  // Exceptions
  EDBConnectionException = EXC;
  EConnectionException = EXC;
  EThisShouldNeverHappenException = EXC;
  ELoginException = EXC;
  EInvalidTokenException = EXC;

  TDBInfo = record
    Hostname,
    Username,
    Password,
    Database: ansistring
  end;

  TUserID = int64;
  TEmail = string;
  TPassword = string;
  THint = string;
  TAccountStatus = Integer;
  TSHA256Hash = string;
  TLoginToken = TSHA256Hash;
  TSalt = TSHA256Hash;
  TPasswordHash = TSHA256Hash;
  TIPAdress = string;
  TName = string;
  TPhoneNumber = string;
  TStreet = string;
  THouseNumber = string;
  TZipCode = string;
  TCity = string;
  TAdditionalAdressInformation = String;

  TAdress = record
    Street: TStreet;
    Number: THouseNumber;
    ZipCode: TZipCode;
    City: TCity;
    AdditionalInformation: TAdditionalAdressInformation;
  end;

  TUserData = record
    UserName,
    FirstName,
    LastName: TName;
    EMail: TEmail;
    Status: TAccountStatus;
    BirthDay: TDate;
    PhoneNumber: TPhoneNumber;
    Adress: TAdress;
  end;

implementation

end.

